#!/usr/bin/python

import sys
import os
import ConfigParser

def now():
    return time.strftime("%Y-%m-%d %H:%M:%S");


config = ConfigParser.ConfigParser()
config.read("stream.conf")

media_plugin = config.get("Media", "engine")
exec("from plugins.media.%s import *" % media_plugin)

media = Media(config)

comm_plugin = config.get("Comm", "engine")
exec("from plugins.comm.%s import *" % comm_plugin)

# Start Our Server:
server = Server(config)

print "--> Starting the server..."

while (server.finish == 0):
    con, client = server.getRequest()

    while True:
        msg = server.getMsg(1024).strip()

        if not msg: break

        elif (msg == "SETUP"):
            setup = server.getMsg(1024).strip().split(" ")
            media.setup(setup[0], setup[1], setup[2], \
                        setup[3], setup[4], setup[5],
                        setup[6], setup[7], setup[8],
                        setup[9])

        elif (msg == "PLAY"):
            media.play()

        elif (msg == "STOP"):
            media.stop()

        elif (msg == "CLOSE"):
            server.finish = 1
            media.stop()
            break

        print "[%s] %s: %s" % (now(), client, msg)

    print "[%s] Closing connection with %s" % (now(), client)
    server.disconnect_client(con)

server.stop()
del(server)
print "--> Server stopped..."
